# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-YAML
Version:	0.88
Release:	1.%{__distinit}%{__distvers}
Summary:	YAML Ain't Markup Language (tm)
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/YAML/
Source0:	http://search.cpan.org/CPAN/authors/id/I/IN/INGY/YAML-%{version}.tar.gz
Patch0:		YAML-0.81-rt74826.patch
Patch1:		YAML-0.88-old-perl.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::MakeMaker)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Carp)
Requires:	perl(Data::Dumper)

# Filter private provides:
# perl(yaml_mapping) perl(yaml_scalar) perl(yaml_sequence)
%global __provides_exclude ^perl\\(yaml_

%description
The YAML.pm module implements a YAML Loader and Dumper based on the YAML 1.0
specification (http://www.yaml.org/spec/). YAML is a generic data serialization
language that is optimized for human readability. It can be used to express the
data structures of most modern programming languages, including Perl.  For
information on the YAML syntax, please refer to the YAML specification.

%prep
%setup -q -n YAML-%{version}

# Upstream "fix" for CPAN RT#73702 in CPAN RT#74826 actually fixes the
# issue in two different ways, and breaks the test suite
%patch0

# Possessive quantifiers require perl ≥ 5.10 (CPAN RT#90593)
%if %(perl -e 'print $] < 5.010 ? 1 : 0;')
%patch1
%endif

# Filter private provides:
# perl(yaml_mapping) perl(yaml_scalar) perl(yaml_sequence)
%global provfilt /bin/sh -c "%{__perl_provides} | grep -v '^perl(yaml_'"
%define __perl_provides %{provfilt}

%build
echo y | perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
%{_fixperms} %{buildroot}

# Removing Test::YAML (at least temporarily) due
# to security concerns and questionable value.
# https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=197539
rm -f	%{buildroot}%{perl_vendorlib}/Test/YAML* \
	%{buildroot}%{_mandir}/man3/Test::YAML*.3*

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%{perl_vendorlib}/YAML/
%{perl_vendorlib}/YAML.pm
%{_mandir}/man3/YAML.3pm*
%{_mandir}/man3/YAML::Any.3pm*
%{_mandir}/man3/YAML::Dumper.3pm*
%{_mandir}/man3/YAML::Dumper::Base.3pm*
%{_mandir}/man3/YAML::Error.3pm*
%{_mandir}/man3/YAML::Loader.3pm*
%{_mandir}/man3/YAML::Loader::Base.3pm*
%{_mandir}/man3/YAML::Marshall.3pm*
%{_mandir}/man3/YAML::Node.3pm*
%{_mandir}/man3/YAML::Tag.3pm*
%{_mandir}/man3/YAML::Types.3pm*

%changelog
* Tue Dec  3 2013 Paul Howarth <paul@city-fan.org> 0.88-1
- Update to 0.88
  - Fixed YAML loading on perl 5.8 (broken in YAML 0.85) by removing
    5.10-specific regex construct
- Update old-perl patch, since the upstream fix doesn't actually work

* Mon Dec  2 2013 Paul Howarth <paul@city-fan.org> 0.87-1
- Update to 0.87
  - Use latest Test::Builder (CPAN RT#90847)

* Tue Nov 26 2013 Paul Howarth <paul@city-fan.org> 0.86-1
- Update to 0.86
  - Revert YAML::Mo (CPAN RT#90817)

* Tue Nov 26 2013 Paul Howarth <paul@city-fan.org> 0.85-1
- Update to 0.85
  - Synopsis in YAML::Dumper didn't work as expected (CPAN RT#19838)
  - Address complex regular subexpression recursion limit (CPAN RT#90593)
  - Upgrade to latest Mo
- This release by INGY -> update source URL
- Add patch to support use with Perl < 5.10

* Fri Jul 13 2012 Paul Howarth <paul@city-fan.org> 0.84-1
- Update to 0.84
  - Resolve distribution error that caused .git to be shipped in the tarball

* Fri Jul 13 2012 Paul Howarth <paul@city-fan.org> 0.83-1
- Update to 0.83
  - Only call stat() and tell() on a filehandle if fileno existed
  - Explicit tied() call on globs to avoid a 5.16 deprecation warning

* Thu Jul 12 2012 Paul Howarth <paul@city-fan.org> 0.82-1
- Update to 0.82
  - Test scalar @array rather than deprecated defined @array (CPAN RT#74226)
- Drop upstreamed patch for CPAN RT#74226

* Tue Jun 12 2012 Paul Howarth <paul@city-fan.org> 0.81-4
- Fix deprecation warning in YAML::Any with Perl 5.15.7 onwards (CPAN RT#74226)

* Thu Apr 19 2012 Paul Howarth <paul@city-fan.org> 0.81-1
- Update to 0.81
  - Test fixes for 5.16 (CPAN RT#74826)
  - YAML::Mo uses Safe Mo (CPAN RT#76664)
- BR:/R: perl(Carp) and perl(Data::Dumper)
- Add patch to fix broken upstream fix for old B::Deparse versions
  (CPAN RT#74826, CPAN RT#74687, CPAN RT#73702)

* Tue Mar 20 2012 Paul Howarth <paul@city-fan.org> 0.80-2
- BR: perl(constant) and perl(Exporter)
- Package the LICENSE file
- Don't need to remove empty directories from buildroot
- Drop support for distributions prior to FC-3:
  - Always run the whole test suite
  - Don't patch away the Perl 5.8.1 requirement
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Sat Feb 11 2012 Paul Howarth <paul@city-fan.org> 0.80-1
- Update to 0.80
  - Work around Perl RT#35857 on old distributions (CPAN RT#73702)
  - Make YAML::Node subclass YAML::Mo::Object as well as Exporter
- Drop upstreamed patch for Perl RT#35857 workaround

* Thu Feb  9 2012 Paul Howarth <paul@city-fan.org> 0.79-1
- Update to 0.79
  - Mo::xxx was causing problems on newer perls and has been removed for now
- Drop UTF8 patch, no longer needed

* Tue Jan  3 2012 Paul Howarth <paul@city-fan.org> 0.78-1
- Update to 0.78
  - Apply patch from ANDK++ to deal with B::Deparse changes
- Upstream no longer shipping POD for YAML::Mo
- Add patch to work around Perl RT#35857 on old distributions

* Thu Sep 29 2011 Paul Howarth <paul@city-fan.org> 0.77-1
- Update to 0.77
  - Add $VERSION back to all modules

* Wed Sep 28 2011 Paul Howarth <paul@city-fan.org> 0.76-1
- Update to 0.76
  - Removed YAML::import per mst

* Tue Sep 27 2011 Paul Howarth <paul@city-fan.org> 0.75-1
- Update to 0.75
  - Switch to Mo for OO (YAML::Mo)
  - use_test_base in Makefile.PL
- Drop bundled Test-Simple as upstream has included needed bits again
- Drop BR: perl(Test::Base) as upstream has bundled it again
- Drop manpage for YAML::Base, no longer included

* Mon Sep 26 2011 Paul Howarth <paul@city-fan.org> 0.74-1
- Update to 0.74
  - Switch to Module::Package
  - Removed extra $VERSION lines from submodules
- Use a patch rather than scripted iconv to fix README encoding
- Don't run release tests as upstream didn't ship them
- Drop release test buildreqs perl(Test::CPAN::Meta),
  perl(Test::MinimumVersion) and perl(Test::Pod)
- BR: perl(Test::Base)
- Package manpage for YAML::Mo
- Filter private provides perl(yaml_mapping), perl(yaml_scalar) and
  perl(yaml_sequence)
- YAML used to bundle a recent copy of bits of Test-Simple that it needed
  but no longer does so, so do it ourselves for support of old releases

* Thu Jun 30 2011 Paul Howarth <paul@city-fan.org> 0.73-2
- Rebuild for perl 5.14.1 in Rawhide
- Add support for perl_bootstrap macro
- Fix dist tag for CentOS 6 and Scientific Linux

* Tue Apr 19 2011 Paul Howarth <paul@city-fan.org> 0.73-1
- Update to 0.73
  - Apply ANDK's patch for 5.14.0 (CPAN RT#62258)
- This release by INGY -> update source URL
- Use %%{_fixperms} macro instead of our own chmod incantation
- Nobody else likes macros for commands
- Update patch for perl 5.8.0 support

* Mon Sep  6 2010 Paul Howarth <paul@city-fan.org> 0.72-1
- Update to 0.72
  - Upgrade to Module::Install 1.00
  - Upgraded author tests via new ADAMK release automation
  - Normalise Ingy's name to ASCII in Makefile.PL so that we don't have
    Unicode in our own META.yml
- Explicitly run author tests

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> 0.71-3
- Rebuild for perl 5.12.1 in Rawhide

* Wed May 12 2010 Paul Howarth <paul@city-fan.org> 0.71-2
- Fix dist tag for RHEL-6 Beta

* Mon Jan  4 2010 Paul Howarth <paul@city-fan.org> 0.71-1
- Update to 0.71 (use UTF-8 encoding in LoadFile/DumpFile: CPAN RT#25434)
- Add patch to support build on perl 5.8.0 (no longer supported upstream)
- Dist tag for Rawhide no longer needs special-casing

* Tue Aug 11 2009 Paul Howarth <paul@city-fan.org> 0.70-1
- Update to 0.70
- New upstream maintainer -> new source URL
- Enable AUTOMATED_TESTING
- BR: perl(Test::CPAN::Meta), perl(Test::MinimumVersion), perl(Test::Pod)
- Switch off verbose test mode

* Thu Dec  4 2008 Paul Howarth <paul@city-fan.org> 0.68-1
- Update to 0.68

* Tue Dec  2 2008 Paul Howarth <paul@city-fan.org> 0.67-1
- Update to 0.67
- ysh moved out to separate distribution, YAML::Shell
- COMPATIBILITY file no longer included in upstream distribution
- More explicit %%files list
- Recode README as UTF8

* Thu Oct 16 2008 Paul Howarth <paul@city-fan.org> 0.66-2
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Apply patch to remove failing test on perl 5.8.0 to allow builds on RHL9 &
  RHEL3
- Run tests in verbose mode

* Fri Sep 28 2007 Paul Howarth <paul@city-fan.org> 0.66-1
- Update to 0.66
- Clarify license as GPL version 1 or later, or Artistic (same as perl)

* Fri Jun 22 2007 Paul Howarth <paul@city-fan.org> 0.65-1
- Update to 0.65

* Mon Mar 26 2007 Paul Howarth <paul@city-fan.org> 0.62-4
- Import from Fedora Extras
- Use search.cpan.org download URL
- Macro-ize commands where possible, use full command paths otherwise
- Include dist tag macros
- Cosmetic spec file changes
- BuildRequire perl >= 3:5.8.3 (regex test fails on 5.8.0)

* Tue Mar 13 2007 Steven Pritchard <steve@kspei.com> 0.62-3
- Use fixperms macro instead of our own chmod incantation.
- Drop Test::Base build dependency to avoid a BR loop.
- BR ExtUtils::MakeMaker.

* Sat Sep 16 2006 Steven Pritchard <steve@kspei.com> 0.62-2
- Fix find option order.

* Fri Jul 07 2006 Steven Pritchard <steve@kspei.com> 0.62-1
- Update to 0.62.
- Removed Test::YAML (bug #197539).

* Mon Jul 03 2006 Steven Pritchard <steve@kspei.com> 0.61-1
- Update to 0.61.

* Sat May 20 2006 Steven Pritchard <steve@kspei.com> 0.58-3
- Rebuild.

* Tue May 09 2006 Steven Pritchard <steve@kspei.com> 0.58-2
- Drop testmore patch.
- Catch Test::YAML module and man page in file list.

* Thu May 04 2006 Steven Pritchard <steve@kspei.com> 0.58-1
- Update to 0.58.
- Small spec cleanups.

* Thu Apr 14 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.39-2
- 0.39.

* Wed Apr  6 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Sat May 15 2004 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0:0.35-0.fdr.5
- Avoid creation of the perllocal.pod file (make pure_install).

* Sun Apr 25 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.35-0.fdr.4
- Require perl(:MODULE_COMPAT_*).
- Cosmetic tweaks (bug 1383).

* Sun Mar 14 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.35-0.fdr.3
- Reduce directory ownership bloat.

* Tue Nov 18 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.35-0.fdr.2
- Use INSTALLARCHLIB workaround in %%install.

* Wed Sep  3 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.35-0.fdr.1
- First build.
